*--  
#INCLUDE	"..\INCLUDE\MAIN.H"


DEFINE CLASS SHeader AS Header
	*--  Header  Smart_Grid
	Name = "SHeader"
	Caption = ""
	Alignment = 2
	FontName = "Arial"
	FontSize = 8
	WordWrap = .T.
	IsSort = .F.
	lnMouseX = 0
	lnMouseY = 0
	IsFont = .F.
	PROCEDURE MouseDown()
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		WITH THIS
			.lnMouseX = nXCoord
			.lnMouseY = nYCoord
			.IsSort = .T.
		ENDWITH
	ENDPROC
	PROCEDURE Click
		*--   SetOrder  Grid
		IF THIS.IsSort
			THIS.IsSort = .F.
			THIS.Parent.Parent.SetOrder(THIS)
		ENDIF
		
	ENDPROC
	PROCEDURE RightClick
		LOCAL lnMesto, llResult
		*-- ,    Header
		llResult = THIS.Parent.Parent.GridHitTest(THIS.lnMouseX, THIS.lnMouseY, @lnMesto)
		IF llResult AND (lnMesto = 1)
			THIS.Parent.Parent.SetOption(THIS)
		ENDIF
	ENDPROC
			PROCEDURE MouseEnter(nButton, nShift, nXCoord, nYCoord) 
				this.Parent.ToolTipText = this.ToolTipText 
			ENDPROC  

			PROCEDURE MouseLeave(nButton, nShift, nXCoord, nYCoord) 
				this.Parent.ToolTipText = "" 
			ENDPROC
ENDDEFINE

*--    Smart_Grid
DEFINE CLASS SColumn AS Column
	FontName = "Arial"
	FontSize = 8
	Name = "SColumn"
	HeaderClass = "SHeader"
	HeaderClassLibrary = "class_define.prg"
	Format = 'Z'
*	DynamicBackColor='IIF(THIS.Ismark AND RECNO()=THIS.PARENT.RecNo,RGB(0,0,128),THIS.BackColor)'
	Default_Visible = .T.
	Default_Width = 0
	Default_Order = 0
	Default_Caption = ""
	Aggregate = ''
	Filtr_Column = ''
	Filtr_Value = ''
	Order_Number = 0
	Caption_Original = ''
	Order_Direct = ''
	Key_Order_Asc = ''
	Key_Order_Desc = ''
	IsNotHide = .F.		&& .T. -   , .F. - 
	IsOrdered = .T.		&& .T. -     
	IsFiltred = .T.		&& .T. -     
	IsAggregate = 1
	Caption_Default = ''	
	IsFont = .F.
*-- IsAggregate = 0 -   
*-- IsAggregate = 1 - 
*-- IsAggregate = 2 - 
*-- IsAggregate = 3 - -
*-- IsAggregate = 4 - 
*-- IsAggregate = 5 - 
	IsEdit = .F.
	Itypf=""
	Ieval="" &&  SLOV.EXPR
	Ievskp="" &&  SLOV.SXPR
	Iclflt="" &&  SLOV.CXPR
	Idobj=0	 && 
	Idcls=0	 &&   len  TYPf "Q"
	Ifiel="" && 
	Ifier="" && repl
	Ialia="" && 
	IOrde="" && orde 
	IsDubl=.F. && 
	IsSkip=.F. &&   
	IsMark=.F.
	ColumnControl = "SText1"	&& ,      
	PROCEDURE Init()
		WITH THIS
			SET TALK OFF
			.AddObject("SText1", "Text_For_Smart_Grid")
*			.AddObject("SKlas1", "Klas_For_Smart_Grid")
			.SText1.Visible = .T.
*			.SKlas1.Visible = .T.

		ENDWITH
	ENDPROC

  PROCEDURE MyControlSource_Assign()
  LPARAMETERS vNewVal
    IF EMPTY(vNewVal) THEN
      RETURN
    ELSE
      THIS.ControlSource = m.vNewVal
    ENDIF
    
   cField = vNewVal
   cAlias = LEFT(cField,AT(".",cField)-1)
   IF EMPTY(cAlias) THEN
    RETURN
   ENDIF
   
   cField = UPPER(RIGHT(cField,(LEN(cField)-RAT(".",cField))))
   IF EMPTY(cField) THEN
    RETURN
   ENDIF
    
   nCnt = AFIELDS(aColumns,cAlias)
   
   FOR nIndex=1 TO nCnt 
     IF (aColumns(nIndex,1) == cField) THEN
       IF (aColumns(nIndex,2) == "L") THEN
         WITH THIS
           .AddObject("Check1", "smartgridcheckbox")
           .SGrdText1.Visible = .F.
           .Check1.Visible = .T.
           .CurrentControl = "Check1"
           .Sparse = .F.
         ENDWITH
         EXIT
       ENDIF
     ENDIF
   ENDFOR
    
  ENDPROC

	PROCEDURE Moved()
		LOCAL i
		THIS.SHeader1.IsSort = .F.
		IF TYPE("THIS.Parent.oAgrGrid")=="O" AND THIS.Parent.oAgrGrid.Visible
			*--    ,   ColumnOrder
			FOR i = 1 TO THIS.Parent.ColumnCount
				THIS.Parent.oAgrGrid.Columns(i).ColumnOrder = THIS.Parent.Columns(i).ColumnOrder
			ENDFOR
		ENDIF
	ENDPROC
	PROCEDURE RightClick
		THIS.Parent.RightClick()
	ENDPROC

	PROCEDURE UpdateData()
		LPARAMETERS lValue
		*--      
*!*			IF UPPER(RIGHT(THIS.ControlSource,4))="TABN"
*!*				ThisForm.ChangeRow(lValue)
*!*			ENDIF
*!*			susp
*!*			IF UPPER(THIS.PARENT.RecordSource)="PRIS"
*!*				REPLACE MMON WITH ""
*!*			ENDIF
	ENDPROC
	
	PROCEDURE GotFocusToTxt()
		IF ! THIS.READONLY
			THIS.ReadOnly=THIS.IsEdit
		ENDIF
		
		*--      SText
*		MESSAGEBOX("**   SText**")
*		MESSAGEBOX(this.ControlSource)
			*if seek(key,tableref,key) 
			*This.value=tableref.name 
			*Else 
			*This.value= 
			*Endif 
	ENDPROC

	PROCEDURE Resize()
		LOCAL i

		IF (TYPE("THIS.Parent.oAgrGrid") == "O") AND THIS.Parent.oAgrGrid.Visible
			FOR i = 1 TO THIS.Parent.ColumnCount
				IF THIS.Parent.oAgrGrid.Columns[i].ColumnOrder = THIS.ColumnOrder
					EXIT
				ENDIF
			ENDFOR
			THIS.Parent.oAgrGrid.Columns[i].Width = THIS.Width
		ENDIF
		IF (TYPE("THISFORM.CmdClcl1") == "O") AND THISFORM.CmdClcl1.Visible
*			thisform.CmdClcl1.top = OBJTOCLIENT(THIS,1)
			thisform.CmdClcl1.Left = OBJTOCLIENT(THIS,2)+OBJTOCLIENT(THIS,3)-40
			thisform.CmdClcl1.Width = 20

			*	thisform.cmd.Left = OBJTOCLIENT(THIS,2)
			*	thisform.cmd.Width = OBJTOCLIENT(THIS,3)
*			thisform.CmdClcl1.Height = OBJTOCLIENT(THIS,4)
*			thisform.CmdClcl1.visible = .F.
		ENDIF
		IF (TYPE("THISFORM.CmdClea1") == "O") AND THISFORM.CmdClea1.Visible
*			thisform.CmdClcl1.top = OBJTOCLIENT(THIS,1)
			thisform.CmdClea1.Left = OBJTOCLIENT(THIS,2)+OBJTOCLIENT(THIS,3)-20
			thisform.CmdClea1.Width = 20

			*	thisform.cmd.Left = OBJTOCLIENT(THIS,2)
			*	thisform.cmd.Width = OBJTOCLIENT(THIS,3)
*			thisform.CmdClcl1.Height = OBJTOCLIENT(THIS,4)
*			thisform.CmdClcl1.visible = .F.
		ENDIF

	ENDPROC

	PROCEDURE MouseMove()
	LPARAMETERS nButton, nShift, nXCoord, nYCoord
		LOCAL lnMesto,lnRelRow
		DO CASE 
		CASE This.Itypf="B" AND THIS.Parent.GridHitTest(nXCoord, nYCoord, @lnMesto, @lnRelRow)				
		This.ToolTipText=""
			IF lnMesto=3 AND THIS.Parent.RelativeRow !=0
				SKIP (lnRelRow-THIS.Parent.RelativeRow)
				This.ToolTipText=TRANSFORM(SUBSTR(EVALUATE(This.Ifier),2,4),"@R 99:99")
*				+"-"+STR(lnRelRow)+"_"+STR(THIS.Parent.RelativeRow)+STR(nYCoord)
				SKIP -(lnRelRow-THIS.Parent.RelativeRow)
			ENDIF	
		CASE This.Itypf $ "NCDMJ" AND !EMPTY(THIS.Ieval) AND THIS.Parent.GridHitTest(nXCoord, nYCoord, @lnMesto, @lnRelRow)				
		This.ToolTipText=""
			IF lnMesto=3 AND THIS.Parent.RelativeRow !=0
				This.ToolTipText=" - Enter, DblClick"
			ENDIF	
		ENDCASE
*!*			IF nButton=1 AND nShift=1
*!*			WAIT WINDOW NOWAIT IIF(THIS.IsMark,"**** ","     ")+STR(nButton,1)+" "+STR(nShift,1)+" "+STR(nXCoord)+STR(nXCoord)+THIS.Controlsource
*!*			NODEFAULT
*!*			ENDIF
*!*			IF nShift=1

*!*	*			THIS.Parent.ActivateCell(THIS.Parent.Activerow,THIS.ColumnOrder)
*!*				THIS.Ismark=!This.Ismark
*!*				IF THIS.Ismark AND THIS.Parent.Recno=RECNO()
*!*					THIS.DynamicBackColor="RGB(0,0,196)"
*!*					THIS.Parent.Highlight=.F.
*!*				ELSE
*!*					THIS.Parent.Highlight=.T.
*!*					THIS.DynamicBackColor="THIS.BackColor"
*!*				ENDIF 

*!*			ENDIF

	ENDPROC
			PROCEDURE MouseEnter(nButton, nShift, nXCoord, nYCoord) 
				this.Parent.ToolTipText = this.ToolTipText 
			ENDPROC  

			PROCEDURE MouseLeave(nButton, nShift, nXCoord, nYCoord) 
				this.Parent.ToolTipText = "" 
			ENDPROC
		
ENDDEFINE

DEFINE CLASS SPage AS Page
	*--  Page  Mpageframe
	Name = "SPage"
	FontName = "Arial"
	FontSize = 8
	Ialia="" && 
	isedit=.F.
	ncol=0 && _  
	idmcls=0
	editkart=.F.
	DIMENSION kntid[1]
	PROCEDURE Activate()
	LOCAL loContr,i
		WITH THIS
		 FOR EACH loContr IN .Controls
				IF UPPER(loContr.Class)=="SMART_GRID" AND ! EMPTY(loContr.RECORDSOURCE)
					SELECT (loContr.RECORDSOURCE)
*					IF EOF() OR RECNO()<=0
*						GO TOP
*					ELSE
*						GO RECNO()
*					ENDIF
					loContr.Refresh()
				ENDIF
				IF UPPER(loContr.Class)=="PGRD_TOOLBAR" 
					loContr.Refresh()
				ENDIF
				IF INLIST(UPPER(loContr.Class),"CTEXTBOX","KCOMB","CEDIT","KTEXT","KDATE","MTEXTBOX","BASECHK") AND TYPE("loContr.mcod")=="N"
					loContr.Refresh()
				ENDIF
			ENDFOR
		ENDWITH
	ENDPROC
	PROCEDURE RightClick()
		Thisform.RightClick()
	ENDPROC
	PROCEDURE TKONT()
	LPARAMETERS lo_kno
		IF !VARTYPE(THIS.kntid) == "N"
			RETURN .F.
		ENDIF
*		ACOPY(THIS.kntid,THISFORM.kntid)
		RETURN THISFORM.TKONT(lo_kno)
	ENDPROC
ENDDEFINE
